package net.vanZeben.ToolRepair;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import org.bukkit.event.Event;
import org.bukkit.event.Event.Priority;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

import com.iConomy.iConomy;
import com.nijikokun.bukkit.Permissions.Permissions;

public class ToolRepair extends JavaPlugin {

    private Logger log = Logger.getLogger("Minecraft");
    private ToolRepairPlayerListener playerListener = new ToolRepairPlayerListener(
            this);
    private ToolRepairBlockListener blockListener = new ToolRepairBlockListener(
            this);
    private ToolRepairSettings trs;
    public iConomy iconomy;
    public Permissions permissions;

    @Override
    public void onEnable() {
        PluginManager pm = getServer().getPluginManager();
        trs = new ToolRepairSettings(this);
        trs.loadSettings("config,yml", "/config.yml");
        checkPlugins();
        PluginDescriptionFile pdfFile = this.getDescription();
        pm.registerEvent(Event.Type.SIGN_CHANGE, blockListener,
                Priority.Normal, this);
        pm.registerEvent(Event.Type.PLAYER_INTERACT, playerListener,
                Priority.Normal, this);
        pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener,
                Priority.Normal, this);

        this.out("Version " + pdfFile.getVersion() + " loaded.");
        if (pm.isPluginEnabled("iConomy")) {
            this.out("ToolRepair Sign Cost: "
                    + ToolRepairSettings.getSignCost());
        }
        this.out("Developed by: " + pdfFile.getAuthors());

    }

    @Override
    public void onDisable() {
        this.out("Disabled");
    }

    private void checkPlugins() {
        List<String> using = new ArrayList<String>();
        Plugin test;
        test = getServer().getPluginManager().getPlugin("Permissions");
        if (test != null) {
            permissions = (Permissions) test;
            if (ToolRepairSettings.usePermissions())
                using.add("Permissions");
        }

        test = getServer().getPluginManager().getPlugin("iConomy");
        if (test != null) {
            iconomy = (iConomy) test;
            if (ToolRepairSettings.useIconomy())
                using.add("iConomy");
        }

        if (using.size() > 0)
            System.out.println("[ToolRepair] Using: "
                    + StringMgmt.join(using, ", "));
    }

    public void out(String message) {
        PluginDescriptionFile pdfFile = this.getDescription();
        log.info("[" + pdfFile.getName() + "] " + message);
    }
}