package net.vanZeben.ToolRepair;

import java.util.ArrayList;
import java.util.Iterator;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.SignChangeEvent;

import com.iConomy.iConomy;

public class ToolRepairBlockListener extends BlockListener {
    private ToolRepair plugin;
    private ToolRepairHelper trh = new ToolRepairHelper();
    private ArrayList<BlockFace> checkFaces = this.getFacesToCheck();

    ToolRepairBlockListener(ToolRepair instance) {

        plugin = instance;
    }

    ToolRepairBlockListener() {
    }

    // EVENT HANDLERS //

    @Override
    public void onSignChange(SignChangeEvent event) {

        if (!plugin.isEnabled()) {
            return;
        }
        String[] tag = new String[6];
        Player player = event.getPlayer();
        tag[0] = "O: " + trh.stripColour(player.getName());
        tag[1] = "------------";
        tag[2] = "[ToolRepair]";
        tag[3] = "[Station]";
        tag[4] = event.getLine(0);
        tag[5] = "O: " + event.getLine(1);

        if (plugin.iconomy.isEnabled()) {

            if (event.getLine(2).equalsIgnoreCase("[ToolRepair]")
                    || event.getLine(3).equalsIgnoreCase("[Station]")) {
                // This will be called if a user attempts to create a station by
                // just using the final syntax and skipping the process
                event.setLine(0, tag[1]);
                event.setLine(1, "DENIED!");
                event.setLine(2, "ACCESS!");
                event.setLine(3, tag[1]);
                player.sendMessage(trh.formatText(ChatColor.RED
                        + "Don't try to cheat the system."));
            } else if (tag[4].equalsIgnoreCase("ToolRepair")) {
                // This will be called if the user wants to make a station
                if (event.getBlock().getType().equals(Material.WALL_SIGN)) {
                    // if its a wall sign
                    if (trh.isBalanceGreaterThanCost(player,
                            ToolRepairSettings.getSignCost())) {
                        // if the users balance is greater then the cost of a
                        // sign
                        if (tag[5].equalsIgnoreCase("O: ")) {
                            // If the user hasnt specified an owner
                            event.setLine(0, tag[0]);
                            player.sendMessage(trh.formatText(ChatColor.GREEN
                                    + "Station Authorized!"));

                        } else {
                            // if the user has specified an owner
                            event.setLine(0, tag[5]);
                            player.sendMessage(trh.formatText(ChatColor.GREEN
                                    + "Station Created for " + event.getLine(1)));
                        }
                        event.setLine(1, tag[1]);
                        event.setLine(2, tag[2]);
                        event.setLine(3, tag[3]);
                        player.sendMessage(trh.formatText(ChatColor.GREEN
                                + iConomy.format(ToolRepairSettings
                                        .getSignCost())
                                + " has been deducted from your account."));
                        trh.subtractMoney(player,
                                ToolRepairSettings.getSignCost());
                    } else {
                        // if the user has no money
                        event.setLine(0, tag[1]);
                        event.setLine(1, "NO MONEY");
                        event.setLine(2, ":'(");
                        event.setLine(3, tag[1]);
                        player.sendMessage(trh.formatText(ChatColor.YELLOW
                                + "Sorry, you dont have enough money."));
                    }
                } else {
                    // if its not a wall sign
                    event.setLine(0, "Won't work!");
                    player.sendMessage(trh.formatText(ChatColor.RED
                            + "ToolRepair Stations only work with wall signs."));
                }
            }
        } else {
            if (tag[4].equalsIgnoreCase("ToolRepair")) {
                // This will be called if the user wants to make a station
                if (event.getBlock().getType().equals(Material.WALL_SIGN)) {
                    // if its a wall sign
                    if (tag[5].equalsIgnoreCase("O: ")) {
                        // If the user has specified an owner
                        event.setLine(0, tag[0]);
                    } else {
                        // if the user hasn't specified an owner
                        event.setLine(0, tag[5]);
                    }
                    event.setLine(1, tag[1]);
                    event.setLine(2, tag[2]);
                    event.setLine(3, tag[3]);
                } else {
                    // if its not a wall sign
                    event.setLine(0, "Won't work!");
                    player.sendMessage(trh.formatText(ChatColor.RED
                            + "ToolRepair Stations only work with wall signs."));
                }
            }
        }
    }

    public void onBlockBreak(BlockBreakEvent event) {
        // this is called on a block break
        Player player = event.getPlayer();
        if (!plugin.isEnabled()) {
            // if the plugin isnt on why bother to check
            return;
        }
        if (event.isCancelled()) {
            // if the block is already cancelled who cares
            return;
        }
        if (relevantSign(event.getBlock())) {
            // if it is a station sign
            if (!(event.getPlayer().isOp())
                    && !(event.getPlayer().getDisplayName()
                            .equalsIgnoreCase(trh.getOwner(event.getBlock())))) {
                // if the player is not op or the owner of the sign
                player.sendMessage(trh
                        .formatText(ChatColor.RED
                                + "Permission denied!  You can't remove repair chest signs."));
                event.setCancelled(true);
            } else {
                // if the player is op
                event.setCancelled(false);
            }
        } else {
            // this applies to the block the sign is on
            Iterator<BlockFace> faces = checkFaces.iterator();
            while (faces.hasNext()) {
                BlockFace face = faces.next();
                if (this.relevantSign(event.getBlock().getRelative(face))) {
                    if (player != null) {
                        // if its a player deny perms
                        player.sendMessage(trh
                                .formatText(ChatColor.RED
                                        + "Permission denied! This block has a ToolRepair sign on it."));
                        player.sendMessage(trh.formatText(ChatColor.RED
                                + "Remove the Sign first."));
                        event.setCancelled(true);
                    }
                    break;
                }
            }
        }
    }

    private boolean relevantSign(Block block) {
        boolean relevant = false;
        if (block.getState() instanceof Sign) {
            // if the sign is a station
            if (((Sign) block.getState()).getLine(2).equalsIgnoreCase(
                    "[TOOLREPAIR]")
                    && ((Sign) block.getState()).getLine(3).equalsIgnoreCase(
                            "[STATION]")) {
                relevant = true;
            }
        }
        return relevant;
    }

    private ArrayList<BlockFace> getFacesToCheck() {
        // adds faces to check
        ArrayList<BlockFace> checkFaces = new ArrayList<BlockFace>();
        checkFaces.add(BlockFace.NORTH);
        checkFaces.add(BlockFace.SOUTH);
        checkFaces.add(BlockFace.EAST);
        checkFaces.add(BlockFace.WEST);
        return checkFaces;
    }

}
