package net.vanZeben.ToolRepair;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import com.iConomy.iConomy;
import com.iConomy.system.Account;

public class ToolRepairHelper {

    public int getTotalCost(ItemStack tool) {

        Material type = null;
        try {
            type = tool.getType();
        } catch (Exception e) {
            return -1;
        }
        int max = type.getMaxDurability();
        int durability = tool.getDurability();
        double ratio = (double) durability / max;
        double cost = 0;
        int blocksUsed = getBlocksUsed(tool);
        String tm = getToolMaterial(tool);

        if (tm.equalsIgnoreCase("air")) {
            return -1;
        }
        if (tm.equalsIgnoreCase("wood")) {
            cost = ToolRepairSettings.getWoodBaseCost() * ratio * blocksUsed;
            return (int) cost;
        } else if (tm.equalsIgnoreCase("stone")) {
            cost = ToolRepairSettings.getStoneBaseCost() * ratio * blocksUsed;
            return (int) cost;
        } else if (tm.equalsIgnoreCase("iron")) {
            if (type == Material.IRON_SWORD) {
                ratio = (double) durability / 250;
            } else if (type == Material.SHEARS) {
                ratio = (double) durability / 239;
            }
            cost = ToolRepairSettings.getIronBaseCost() * ratio * blocksUsed;
            return (int) cost;
        } else if (tm.equalsIgnoreCase("gold")) {
            cost = ToolRepairSettings.getGoldBaseCost() * ratio * blocksUsed;
            return (int) cost;
        } else if (tm.equalsIgnoreCase("diamond")) {
            cost = ToolRepairSettings.getDiamondBaseCost() * ratio * blocksUsed;
            return (int) cost;
        } else if (tm.equalsIgnoreCase("air")) {
            return -1;
        }

        return -1;
    }

    public String getToolMaterial(ItemStack tool) {

        Material type = null;

        try {
            type = tool.getType();
        } catch (Exception e) {
            type = Material.AIR;
        }
        if (type == Material.WOOD_AXE || type == Material.WOOD_HOE
                || type == Material.WOOD_PICKAXE || type == Material.WOOD_SPADE
                || type == Material.WOOD_SWORD) {
            return "wood";
        } else if (type == Material.STONE_AXE || type == Material.STONE_HOE
                || type == Material.STONE_PICKAXE
                || type == Material.STONE_SPADE || type == Material.STONE_SWORD
                || type == Material.LEATHER_BOOTS
                || type == Material.LEATHER_HELMET
                || type == Material.LEATHER_LEGGINGS
                || type == Material.LEATHER_CHESTPLATE) {
            return "stone";
        } else if (type == Material.IRON_AXE || type == Material.IRON_HOE
                || type == Material.IRON_PICKAXE || type == Material.IRON_SPADE
                || type == Material.IRON_SWORD || type == Material.IRON_BOOTS
                || type == Material.IRON_HELMET
                || type == Material.IRON_LEGGINGS
                || type == Material.IRON_CHESTPLATE || type == Material.SHEARS) {
            return "iron";
        } else if (type == Material.GOLD_AXE || type == Material.GOLD_HOE
                || type == Material.GOLD_PICKAXE || type == Material.GOLD_SPADE
                || type == Material.GOLD_SWORD || type == Material.GOLD_BOOTS
                || type == Material.GOLD_HELMET
                || type == Material.GOLD_LEGGINGS
                || type == Material.GOLD_CHESTPLATE) {
            return "gold";
        } else if (type == Material.DIAMOND_AXE || type == Material.DIAMOND_HOE
                || type == Material.DIAMOND_PICKAXE
                || type == Material.DIAMOND_SPADE
                || type == Material.DIAMOND_SWORD
                || type == Material.DIAMOND_BOOTS
                || type == Material.DIAMOND_HELMET
                || type == Material.DIAMOND_LEGGINGS
                || type == Material.DIAMOND_CHESTPLATE) {
            return "diamond";
        } else if (type == Material.AIR) {
            return "air";
        }
        return "";
    }

    public int getBlocksUsed(ItemStack tool) {

        Material type = null;
        try {
            type = tool.getType();
        } catch (Exception e) {
            type = Material.AIR;
        }

        int blocksUsed = 1;

        if (type == Material.WOOD_SPADE || type == Material.STONE_SPADE
                || type == Material.IRON_SPADE || type == Material.GOLD_SPADE
                || type == Material.DIAMOND_SPADE)
            blocksUsed = 1;
        else if (type == Material.WOOD_HOE || type == Material.WOOD_SWORD
                || type == Material.STONE_HOE || type == Material.STONE_SWORD
                || type == Material.IRON_HOE || type == Material.IRON_SWORD
                || type == Material.GOLD_HOE || type == Material.GOLD_SWORD
                || type == Material.DIAMOND_HOE
                || type == Material.DIAMOND_SWORD || type == Material.SHEARS)
            blocksUsed = 2;
        else if (type == Material.WOOD_AXE || type == Material.WOOD_PICKAXE
                || type == Material.STONE_AXE || type == Material.STONE_PICKAXE
                || type == Material.IRON_AXE || type == Material.IRON_PICKAXE
                || type == Material.GOLD_AXE || type == Material.GOLD_PICKAXE
                || type == Material.DIAMOND_AXE
                || type == Material.DIAMOND_PICKAXE)
            blocksUsed = 3;
        else if (type == Material.LEATHER_BOOTS || type == Material.IRON_BOOTS
                || type == Material.GOLD_BOOTS
                || type == Material.DIAMOND_BOOTS)
            blocksUsed = 4;
        else if (type == Material.LEATHER_HELMET
                || type == Material.IRON_HELMET || type == Material.GOLD_HELMET
                || type == Material.DIAMOND_HELMET)
            blocksUsed = 5;
        else if (type == Material.LEATHER_LEGGINGS
                || type == Material.IRON_LEGGINGS
                || type == Material.GOLD_LEGGINGS
                || type == Material.DIAMOND_LEGGINGS)
            blocksUsed = 7;
        else if (type == Material.LEATHER_CHESTPLATE
                || type == Material.IRON_CHESTPLATE
                || type == Material.GOLD_CHESTPLATE
                || type == Material.DIAMOND_CHESTPLATE)
            blocksUsed = 8;
        else if (type == Material.AIR)
            return 0;

        return blocksUsed;
    }

    public boolean isBalanceGreaterThanCost(Player player, int cost) {

        String playerName = player.getName();
        double balance = iConomy.getAccount(playerName).getHoldings().balance();

        if (balance > cost)
            return true;
        else
            return false;
    }

    public void subtractMoney(Player player, int cost, String owner) {

        String playerName = player.getName();
        Account account = iConomy.getAccount(playerName);
        account.getHoldings().subtract(cost);
        String balance = account.getHoldings().toString();
        player.sendMessage(this.formatText(ChatColor.GREEN + "You paid "
                + iConomy.format(cost) + " for that repair."));
        player.sendMessage(this.formatText(ChatColor.GREEN + "You now have "
                + balance + "."));
        player.sendMessage(this.formatText(ChatColor.GREEN + "Tool repaired!"));
        Account accountOwn = iConomy.getAccount(owner);
        accountOwn.getHoldings().add(cost);
    }

    public void subtractMoney(Player player, int cost) {

        String playerName = player.getName();
        Account account = iConomy.getAccount(playerName);
        account.getHoldings().subtract(cost);
    }

    public String getOwner(Sign sign) {

        String ownerOrig = sign.getLine(0);
        String owner = "";

        for (int i = 3; i < ownerOrig.length(); i++) {

            owner += ownerOrig.charAt(i);

        }
        return stripColour(owner);
    }

    public String getOwner(Block block) {

        String owner = "";

        if (block.getState() instanceof Sign) {
            String ownerOrig = ((Sign) block.getState()).getLine(0);
            for (int i = 3; i < ownerOrig.length(); i++) {
                owner += ownerOrig.charAt(i);
            }
        }
        return stripColour(owner);
    }

    public static boolean hasItem(Player player, ItemStack item) {
        ItemStack[] inventory = player.getInventory().getContents();
        for (ItemStack x : inventory) {
            if ((x != null) && (x.getType().equals(item))) {
                return true;
            }
        }
        return false;
    }

    public static void removeItem(Player player, ItemStack item) {
        ItemStack[] inventory = player.getInventory().getContents();
        for (ItemStack x : inventory)
            if ((x != null) && (x.getType().equals(item))) {
                if (x.getAmount() == 1) {
                    x.setTypeId(0);
                    x.setAmount(0);
                    player.getInventory().setContents(inventory);
                } else {
                    x.setAmount(x.getAmount() - 1);
                    player.getInventory().setContents(inventory);
                }
                return;
            }
    }

    public String formatText(String msg) {
        String output = ChatColor.BLUE + "[" + ChatColor.AQUA + "ToolRepair"
                + ChatColor.BLUE + "] " + msg;
        return output;
    }

    public String stripColour(String s) {
        String out = "";
        for (int i = 0; i < s.length() - 1; i++) {
            String c = s.substring(i, i + 1);
            if (c.equals("") || c.equals(""))
                i += 1;
            else
                out += c;
        }
        return out;
    }
}