package net.vanZeben.ToolRepair;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.inventory.ItemStack;

import com.iConomy.iConomy;

public class ToolRepairPlayerListener extends PlayerListener {
    private ToolRepair plugin;
    private ToolRepairHelper trh = new ToolRepairHelper();

    ToolRepairPlayerListener() {

    }

    ToolRepairPlayerListener(ToolRepair instance) {
        plugin = instance;

    }

    public void onPlayerInteract(PlayerInteractEvent event) {
        Player player = event.getPlayer();
        Block block = event.getClickedBlock();

        boolean useIC = plugin.getServer().getPluginManager()
                .isPluginEnabled("iConomy");
        if (block != null) {
            Material blockType = block.getType();

            ItemStack item = event.getItem();
            if (blockType.equals(Material.WALL_SIGN)) {
                int cost = trh.getTotalCost(item);
                if (useIC) {
                    Sign sign = (Sign) block.getState();
                    if (sign.getLine(2).equalsIgnoreCase("[toolrepair]")
                            && sign.getLine(3).equalsIgnoreCase("[station]")) {

                        if (event.getAction().equals(Action.LEFT_CLICK_BLOCK)) {

                            if (cost < 0) {
                                player.sendMessage(trh.formatText(ChatColor.RED
                                        + "Item not a tool."));
                                return;
                            }

                            else if (item.getDurability() == 0 && cost >= 0) {
                                player.sendMessage(trh
                                        .formatText(ChatColor.GREEN
                                                + "Tool at full durability."));
                                return;
                            } else {
                                if (cost < 0) {
                                    player.sendMessage(trh
                                            .formatText(ChatColor.RED
                                                    + "Item not a tool."));
                                    return;
                                }
                                player.sendMessage(trh
                                        .formatText(ChatColor.GOLD
                                                + "It will cost "
                                                + iConomy.format(cost)
                                                + " to repair your tool."));
                            }
                        } else if (event.getAction().equals(
                                Action.RIGHT_CLICK_BLOCK)) {

                            if (cost < 0) {
                                player.sendMessage(trh.formatText(ChatColor.RED
                                        + "Item not a tool."));
                                return;
                            }

                            else if (item.getDurability() == 0 && cost >= 0) {
                                player.sendMessage(trh
                                        .formatText(ChatColor.GREEN
                                                + "Tool at full durability."));
                                return;
                            }

                            else if (!trh
                                    .isBalanceGreaterThanCost(player, cost)) {
                                player.sendMessage(trh
                                        .formatText(ChatColor.YELLOW
                                                + "Not enough money to repair."));
                                return;
                            } else {
                                item.setDurability((short) 0);
                                item.getData();
                                trh.subtractMoney(player, cost, trh.getOwner(sign));
                            }
                        } else {
                            player.sendMessage(trh
                                    .formatText(ChatColor.RED
                                            + "You do not have permission for this sign."));
                        }
                    }
                } else {
                    Sign sign = (Sign) block.getState();
                    if (sign.getLine(2).equalsIgnoreCase("[toolrepair]")
                            && sign.getLine(3).equalsIgnoreCase("[station]")) {

                        if (event.getAction().equals(Action.RIGHT_CLICK_BLOCK)
                                || event.getAction().equals(
                                        Action.LEFT_CLICK_BLOCK)) {

                            if (cost < 0
                                    || trh.getToolMaterial(item)
                                            .equalsIgnoreCase("air")) {
                                player.sendMessage(trh.formatText(ChatColor.RED
                                        + "Item not a tool."));
                                return;
                            }

                            else if (item.getDurability() == 0 && cost >= 0) {
                                player.sendMessage(trh
                                        .formatText(ChatColor.GREEN
                                                + "Tool at full durability."));
                                return;
                            }

                            else {
                                item.setDurability((short) 0);
                                player.sendMessage(trh
                                        .formatText(ChatColor.GREEN
                                                + "Tool repaired!"));
                            }
                        } else {
                            player.sendMessage(trh
                                    .formatText(ChatColor.RED
                                            + "You do not have permission for this sign."));
                        }
                    }
                }
            }
        }

    }
}
